Attribute VB_Name = "DFCom"
Option Explicit

' ###########################################
' Constructor: B.Ottmann
' Umsetztung des C-Headerfiles nach VB-Modul
' ###########################################

'Public Const SERVER_PORT As Long = 8000    ' COM-Server Port Standard bei W&T
Public Const MB_ADD_OFFLINE As Long = &HFE  ' Mod-Bus-Adresse Offline

' Nummer der Speichergroesse fuer Listen. Muss beim AEIII+ immer "0" sein
' (ist vom Timeboy uebernommen).
' Es sind 100kByte fuer Listen fest eingestellt.
Public Const FIX_LISTMEMSIZENUM As Long = 0

' Fehlerdefinitionen
Public Const ERROR_NO            As Long = 0  ' Kein Fehler
Public Const ERROR_CRC           As Long = 1  ' CRC Fehler
Public Const ERROR_COM_INIT      As Long = 2  ' Oeffnen der Schnittstelle fehlgeschlagen
Public Const ERROR_COM_CLOSED    As Long = 3  ' Schnittstelle ist geschlossen
Public Const ERROR_COM           As Long = 4  ' Allgemeiner Fehler waehrend Kommunikation
Public Const ERROR_NO_ANSWER     As Long = 5  ' Geraet antwortet nicht mehr
Public Const ERROR_AT_SENDING    As Long = 6  ' Fehler waehrend senden eingetreten
Public Const ERROR_AT_RECIEVING  As Long = 7  ' Fehler waehrend empfang eingetreten
Public Const ERROR_SENDER        As Long = 8  ' Antwort von falschem Geraet oder Antwort nicht sinnvoll
Public Const ERROR_BUS_NUM       As Long = 9  ' Keine gueltige Busnummer (1 - 31, 254)
Public Const ERROR_CHANNEL       As Long = 10 ' Kanal nicht vorhanden oder nicht erstellbar.
Public Const ERROR_OPEN          As Long = 11 ' Oeffnen einer Datei gescheitert
Public Const ERROR_FORMAT        As Long = 12 ' z.B. falsches Format einer Setup-Datei
Public Const ERROR_LIST          As Long = 13 ' Fehler bei Listendatenverarbeitung
Public Const ERROR_FW_VERSION    As Long = 14 ' Firmwareversion nicht kompatible zu Routine
Public Const ERROR_IS_DATA       As Long = 15 ' Es sind noch Daten im Geraet vorhanden.
Public Const ERROR_BREAK         As Long = 16 ' Durchfuehrung wurde von Anwender abgebrochen
Public Const ERROR_NO_RD         As Long = 17 ' Keine Datensatzbeschreibung im Kanal geladen.
Public Const ERROR_NO_LD         As Long = 18 ' Keine Listenbeschreibung im Kanal geladen.
Public Const ERROR_FLASH_PROG    As Long = 19 ' Fehler beim Programmieren des Flash, Firmware.
Public Const ERROR_RANGE         As Long = 20 ' Parameter einer Funktion ausserhalb ihres Gueltigkeitsbereiches.
Public Const ERROR_NOT_DEFINED   As Long = 21 ' Globale Variable nicht definiert.
Public Const ERROR_NO_DATA       As Long = 22 ' Anfrage obwohl keine Daten.

' Funktionen die von der DLL "DfCom.Dll" unterstuetzt werden
' Nutzung zweier Buffertypen (String oder Bytearray)
' - as String
' - as Byte fuer Array mit Bytewerten Endung B fuer Byte

' ------------>Allgemeine Funktionen<-----------
' ##############################################

' Initialisiert die Serielle Schnittstelle
Public Declare Function DFCComOpenSerial Lib "DFComDll" Alias _
"_DFCComOpenSerial@16" (ByVal ComNum As Long, ByVal ComPort As String, ByVal BaudRate As Long, ByVal TimeOut As Long) As Long
Public Declare Function DFCComInit Lib "DFComDll" Alias _
"_DFCComInit@4" (ByVal ComNum As Long) As Long

' Initialisiert die Socketschnittstelle
Public Declare Function DFCComOpenSocket Lib "DFComDll" Alias _
"_DFCComOpenSocket@16" (ByVal ComNum As Long, ByVal RemoteIP As String, ByVal PortNum As Long, ByVal TimeOut As Long) As Long
Public Declare Function DFCComOpen Lib "DFComDll" Alias _
"_DFCComOpen@8" (ByVal ComNum As Long, ByVal szHost As String) As Long
'Public Declare Function DFCComOpenB Lib "DFComDll" Alias _
'"_DFCComOpen@8" (ByVal ComNum As Long, ByRef szHost As Byte) As Long

' Initialisiert die PZE Master IV Schnittstellen
Public Declare Function DFCComOpenIV Lib "DFComDll" Alias _
"_DFCComOpenIV@24" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal ComType As Long, ByVal szComString As String, ByVal ComValue As Long, ByVal ComTimeOut As Long) As Long

' Schliesst die Serielle bzw. die TCP/IP-Verbindung
Public Declare Sub DFCComClose Lib "DFComDll" Alias _
"_DFCComClose@4" (ByVal ComNum As Long)

' Pruefen ob AEIII+ am Bus angeschlossen ist.
' Nur gueltig wenn die angegebene Verbindung geoeffnet wurde.
Public Declare Function DFCCheckDevice Lib "DFComDll" Alias _
"_DFCCheckDevice@16" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef Error As Long, ByVal DevicePollRetry As Long) As Long
Public Declare Function DFCCheckAE Lib "DFComDll" Alias _
"_DFCCheckAE@8" (ByVal ComNum As Long, ByVal BusNum As Long) As Long

' Stellt die Uhrzeit des Geraetes ein.
Public Declare Function DFCComSetTime Lib "DFComDll" Alias _
"_DFCComSetTime@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal DatUhr As String) As Long
Public Declare Function DFCComSetTimeB Lib "DFComDll" Alias _
"_DFCComSetTime@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef DatUhr As Byte) As Long

' Liest Datum/Uhrzeit des Geraetes aus.
Public Declare Function DFCComGetTime Lib "DFComDll" Alias _
"_DFCComGetTime@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal DatUhr As String) As Long
Public Declare Function DFCComGetTimeB Lib "DFComDll" Alias _
"_DFCComGetTime@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef DatUhr As Byte) As Long

' Sendet eine Meldung an das Geraet mit der Busnummer BusNum.
' Zeilenumbruch mit dem Zeichen Chr(13).
' Immer wenn das Zeichen erkannt wird, wird eine neue Zeile angefangen.
Public Declare Function DFCComSendMessage Lib "DFComDll" Alias _
"_DFCComSendMessage@28" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal AnzeigeZeit As Byte, ByVal Aktion As Byte, ByVal Piepser As Byte, ByVal Nachricht As String, ByVal Laenge As Long) As Long

'Sendet einen Infotext an das Gert mit der Busnummer BusNum.
Public Declare Function DFCComSendInfotext Lib "DFComDll" Alias _
"_DFCComSendInfotext@16" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal InfoText As String, ByVal Length As Long) As Long

' Seriennummer aus Geraet auslesen
Public Declare Function DFCGetSeriennummer Lib "DFComDll" Alias _
"_DFCGetSeriennummer@16" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef Error As Long, ByRef SerialNum As Long) As Long

' Namen fuer Logdatei angeben
Public Declare Sub DFCSetLogFileName Lib "DFComDll" Alias _
"_DFCSetLogFileName@8" (ByVal ComNum As Long, ByVal FileName As String)
' Log - Funktionalitaet fuer den Kanal einschalten
Public Declare Sub DFCSetLogOn Lib "DFComDll" Alias _
"_DFCSetLogOn@4" (ByVal ComNum As Long)
'Log - Funktionalitaet wird abgeschaltet.
Public Declare Sub DFCSetLogOff Lib "DFComDll" Alias _
"_DFCSetLogOff@4" (ByVal ComNum As Long)

' Rueckruffunktion fuer Fortschrittsanzeige
Public Declare Sub DFCSetCallBack Lib "DFComDll" Alias _
"_DFCSetCallBack@8" (ByVal ComNum As Long, ByVal CBFunction As Long)

' Loest Errorcode in Textensprechung auf.
Public Declare Sub DFCGetErrorText Lib "DFComDll" Alias _
"_DFCGetErrorText@20" (ByVal ComNum As Long, ByVal Error As Long, ByVal Language As Long, ByVal Text As String, ByVal Length As Long)

' Setzen des Wertes einer Globalen Variablen.
Public Declare Function DFCSetGlobVar Lib "DFComDll" Alias _
"_DFCSetGlobVar@24" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal GlobVar As String, ByVal FuncType As Long, ByVal Value As String, ByRef Error As Long) As Long
' Ermitteln des Wertes einer Globalen Variablen.
Public Declare Function DFCGetGlobVar Lib "DFComDll" Alias _
"_DFCGetGlobVar@28" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal GlobVar As String, ByVal FuncType As Long, ByVal Value As String, ByVal ValueLength As Long, ByRef Error As Long) As Long

' Relais fuer Zeit X schliessen
Public Declare Function DFCCloseRelay Lib "DFComDll" Alias _
"_DFCCloseRelay@20" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal Num As Long, ByVal CloseTime As Long, ByRef Error As Long) As Long
' Status fuer Relais abfragen
Public Declare Function DFCGetRelayState Lib "DFComDll" Alias _
"_DFCGetRelayState@24" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal Num As Long, ByRef State As Long, ByRef CloseTime As Long, ByRef Error As Long) As Long
' Relais oeffnen
Public Declare Function DFCOpenRelay Lib "DFComDll" Alias _
"_DFCOpenRelay@16" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal Num As Long, ByRef Error As Long) As Long


' -------->Funktionen fuer Setup<------------
' ###########################################

'Setup-Daten aus Datei (*.aes) lesen und in AEIII+ bertragen.
Public Declare Function DFCSetupLaden Lib "DFComDll" Alias _
"_DFCSetupLaden@16" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal szFileName As String, ByRef Error As Long) As Long
'Setup-Daten aus AEIII+ lesen und in Datei (*.aes) bertragen.
Public Declare Function DFCDownload Lib "DFComDll" Alias _
"_DFCDownload@16" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal szFileName As String, ByRef Error As Long) As Long


' ------------>Funktionen fr Daten im AEIII+<-----------
' #######################################################

' Funktionen zum Datentransport
' Loeschen der Daten im AEIII+
Public Declare Function DFCComClearData Lib "DFComDll" Alias _
"_DFCComClearData@8" (ByVal ComNum As Long, ByVal BusNum As Long) As Long

' Datensatz auslesen und Busnummer fuer Abfrage mit GetDatensatz bekanntgeben.
Public Declare Function DFCComCollectData Lib "DFComDll" Alias _
"_DFCComCollectData@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef Error As Long) As Long

' Gibt genau einen Datensatz an die aufrufende Anwendung zurueck.
Public Declare Function DFCComGetDatensatz Lib "DFComDll" Alias _
"_DFCComGetDatensatz@16" (ByVal ComNum As Long, ByVal Buffer As String, ByRef Laenge As Long, ByRef Error As Long) As Long
Public Declare Function DFCComGetDatensatzB Lib "DFComDll" Alias _
"_DFCComGetDatensatz@16" (ByVal ComNum As Long, ByRef Buffer As Byte, ByRef Laenge As Long, ByRef Error As Long) As Long

' Datensatzbeschreibungen aus dem Geraet laden.
Public Declare Function DFCLoadDatensatzbeschreibung Lib "DFComDll" Alias _
"_DFCLoadDatensatzbeschreibung@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef Error As Long) As Long
'Anzahl der ausgelesenen Datensatzbeschreibungen (nur gueltig wenn vorher die Funktion "DFCLoadDatensatzbeschreibung" aufgerufen wurde).
Public Declare Function DFCDatBCnt Lib "DFComDll" Alias _
"_DFCDatBCnt@4" (ByVal ComNum As Long) As Long
' Daten einer Datensatzbeschreibung abrufen
' (nur gueltig wenn vorher die Funktion "DFCLoadDatensatzbeschreibung" aufgerufen wurde). Im AEIII+ knnen Datenstze mit unterschiedlichem Format gespeichert werden. Im Setup-Programm werden die Datenstze unter dem Punkt "Datensatzbeschreibung" festgelegt. Die erste Datensatzbeschreibung im Setup-Baum hat die Nummer 0, die zweite die Nummer 1 ...
Public Declare Function DFCDatBDatensatz Lib "DFComDll" Alias _
"_DFCDatBDatensatz@16" (ByVal ComNum As Long, ByVal DatBeschreibungNum As Long, ByVal Name As String, ByRef Felder As Long) As Long
' Daten eines Feldes einer Datensatzbeschreibung abrufen
' (nur gueltig wenn vorher die Funktion "DFCLoadDatensatzbeschreibung" aufgerufen wurde).
Public Declare Function DFCDatBFeld Lib "DFComDll" Alias _
"_DFCDatBFeld@24" (ByVal ComNum As Long, ByVal DatBeschreibungNum As Long, ByVal Feld As Long, ByVal Name As String, ByRef Typ As Long, ByRef FLen As Long) As Long


' -------->Funktionen fuer Listen<-----------
' ###########################################

' Daten einer Liste in den internen Buffer der DLL schreiben.
' Die Listendaten muessen immer exakt mit der Listenbeschreibung im Setup uebereinstimmen.
Public Declare Function DFCMakeListe Lib "DFComDll" Alias _
"_DFCMakeListe@24" (ByVal ComNum As Long, ByVal ListNum As Long, ByVal ListCnt As Long, ByVal ListSize As Long, ByVal Buf As String, ByVal ListMemSizeNum As Long) As Long
Public Declare Function DFCMakeListeB Lib "DFComDll" Alias _
"_DFCMakeListe@24" (ByVal ComNum As Long, ByVal ListNum As Long, ByVal ListCnt As Long, ByVal ListSize As Long, ByRef Buf As Byte, ByVal ListMemSizeNum As Long) As Long

' Listendaten vom internen Buffer der DLL in das Geraet laden.
Public Declare Function DFCLoadListen Lib "DFComDll" Alias _
"_DFCLoadListen@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef Error As Long) As Long

' Die Listendaten im Buffer der DLL werden geloescht
Public Declare Sub DFCClrListenBuffer Lib "DFComDll" Alias _
"_DFCClrListenBuffer@4" (ByVal ComNum As Long)

' Listenbeschreibungen aus dem AEIII+ lesen. Die Datensatzbeschreibungen
' werden im PC in einen Buffer abgelegt und knnen mit den Funktionen "DFCDatB..." ausgewertet werden.
Public Declare Function DFCLoadListenbeschreibung Lib "DFComDll" Alias _
"_DFCLoadListenbeschreibung@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByRef Error As Long) As Long
' Anzahl der ausgelesenen Listenbeschreibungen
' (nur gltig wenn vorher die Funktion "DFCLoadListenbeschreibung" aufgerufen wurde).
Public Declare Function DFCListBCnt Lib "DFComDll" Alias _
"_DFCListBCnt@4" (ByVal ComNum As Long) As Long
' Daten einer Listenbeschreibung abrufen
' (nur gltig wenn vorher die Funktion "DFCLoadListenbeschreibung" aufgerufen wurde). Im AEIII+ knnen Datenstze mit unterschiedlichem Format gespeichert werden. Im Setup - Programm werden die Datenstze unter dem Punkt "Datensatzbeschreibung" festgelegt. Die erste Datensatzbeschreibung im Setup-Baum hat die Nummer 0, die zweite die Nummer 1 ...
Public Declare Function DFCListBDatensatz Lib "DFComDll" Alias _
"_DFCListBDatensatz@20" (ByVal ComNum As Long, ByVal DatBeschreibungNum As Long, ByVal Name As String, ByRef Felder As Long, ByRef Variable As Long) As Long
' Daten eines Feldes einer Datensatzbeschreibung abrufen
' (nur gltig wenn vorher die Funktion "DFCLoadListenbeschreibung" aufgerufen wurde).
Public Declare Function DFCListBFeld Lib "DFComDll" Alias _
"_DFCListBFeld@24" (ByVal ComNum As Long, ByVal DatBeschreibungNum As Long, ByVal Feld As Long, ByVal Name As String, ByRef Typ As Long, ByRef FLen As Long) As Long


' ------------>Funktionen fuer Zutrittskontrolllisten<-----------
' ###############################################################
' Daten einer Liste in den internen Buffer der DLL schreiben.
' Die Listendaten muessen immer exakt mit der Listenbeschreibung im Setup uebereinstimmen.
Public Declare Function DFCMakeEntranceList Lib "DFComDll" Alias _
"_DFCMakeEntranceList@24" (ByVal ComNum As Long, ByVal ListNum As Long, ByVal LineCount As Long, ByVal ListSize As Long, ByVal Buf As String, ByRef Error As Long) As Long
Public Declare Function DFCMakeEntranceListeB Lib "DFComDll" Alias _
"_DFCMakeEntranceList@24" (ByVal ComNum As Long, ByVal ListNum As Long, ByVal LineCount As Long, ByVal ListSize As Long, ByRef Buf As Byte, ByRef Error As Long) As Long

' Listendaten vom internen Buffer der DLL in das Geraet laden.
Public Declare Function DFCLoadEntranceList Lib "DFComDll" Alias _
"_DFCLoadEntranceList@12" (ByVal ComNum As Long, ByVal BusNum As Long, ByVal ListNum As Long, ByRef Error As Long) As Long

' Die Listendaten im Buffer der DLL werden geloescht
Public Declare Sub DFCClearEntranceListBuffer Lib "DFComDll" Alias _
"_DFCClearEntranceListBuffer@4" (ByVal ComNum As Long, ByVal ListNum As Long)

