//! \file AEErrorDef.h
//! \brief Fehlerdefinitionen.
//////////////////////////////////////////////////////////////////////

#ifndef _AEERRORDEF_H_
#define _AEERRORDEF_H_

// CChannelBase
#define IV_ERROR_SUCCESS               0 // Funktion erfolgreich durchgefuehrt
#define IV_ERROR_FAIL                  100 // Funktionsausfuehrung fehlgeschlagen.
#define IV_ERROR_CHANNEL_OPEN          2 // Schnittstelle des Kanals konnte nicht geoffnet werden.
#define IV_ERROR_CHANNEL_OPEN_REMOTE   2 // Schnittstelle wurde von Remote geschlossen. (Nur TCP/IP)
#define IV_ERROR_CHANNEL_CLOSED        3 // Schnittstelle des Kanals ist geschlossen
#define IV_ERROR_CHANNEL_COMMUNICATION 4 // Allgemeiner Fehler bei der Kommunikation aufgetreten.
#define IV_ERROR_RECEIVE               5 // Ein Zeichen konnte nicht gelesen werden.
#define IV_ERROR_CHANNEL               10 // Kanalobjekt nicht vorhanden oder erstellbar
#define IV_ERROR_TRANSMIT              6 // Ein Zeichen konnte nicht geschrieben werden.

// CChannel4Base
#define IV_ERROR_CRC_HEAD              1 // CRC - Paketkopf war falsch.
#define IV_ERROR_CRC_PACKET            1 // CRC - Gesamtpaket war falsch.
#define IV_ERROR_CRC_SEGMENT           1 // CRC von uebertragenen Segment falsch.
#define IV_ERROR_PACKETLENGTH          4 // Die Laengenangabe des Pakets liegt auserhalb ihrer Grenzen.
#define IV_ERROR_BREAK                 16 // Abbruch durch Benutzer (CallBack-Funktion)
#define IV_ERROR_NO_REQUEST            4 // Aktive Antwort kam nicht.
#define IV_ERROR_ADDRESS               8 // Die Adressen stimmen nicht ueberein.
#define IV_ERROR_COMMAND               4 // Empfangenes Kommandobyte unbekannt.
#define IV_ERROR_SKIPCOUNT             4 // Anzahl IV_SKIPCOUNT erreicht
#define IV_ERROR_START_IN_PACKET       4 // Startzeichen im gelesenen Datenstrom
#define IV_ERROR_ESCAPE                4 // Gelesenes Escapezeichen waehrend Escapemodus
#define IV_ERROR_ESCAPESEQUENZ         4 // Gelesene Escapesequenz undefiniert
#define IV_ERROR_INTERN                4 // Alles was waehrend der Routinenarbeit nicht auftreten darf
#define IV_ERROR_FUNCTION_UNAVAILABLE  27 // Funktion steht im vorliegenden Fall nicht zur Verfuegung.
#define IV_ERROR_UNREACHABLE           5 // Geraet unerreichbar (Antwortet nicht mehr)

// Zu entfernen
#define IV_ERROR_DEVICE_ID_REMOTE      9
#define IV_ERROR_BOOTVERSION           24

// Zusaetzliche Fehlercodes
#define IV_ERROR_FILE_OPEN             11 // Eine Datei konnte nicht geoffnet worden.
#define IV_ERROR_FILE_FORMAT           12 // Das Format einer Datei stimmt nicht mit dem geforderten ueberein.
#define IV_ERROR_LIST_PROCESSING       13 // Bei der Verarbeitung von Listendaten trat ein Fehler auf.
#define IV_ERROR_VERSION_FIRMWARE      14 // Firmwareversion ist nicht mit der abzuarbeitenden Routine kompatibel.
#define IV_ERROR_DATA_AVAILABLE        15 // Die geforderte Aktion wrde noch vorhandene Daten lschen.
#define IV_ERROR_USER_CANCEL           16 // Die durchzufhrende Aktion wurde vom Benutzer abgebrochen.
#define IV_ERROR_DESCRIPTION_LIST_UNLOADED   17 // Fr die Verarbeitung werden die Listenbeschreibungen gefordert, diese sind jedoch nicht vorhanden.
#define IV_ERROR_DESCRIPTION_RECORD_UNLOADED 18 // Fr die Verarbeitung werden die Datensatzbeschreibungen gefordert, diese sind jedoch nicht vorhanden.
#define IV_ERROR_FUNCTION_PARAMETER    20 // bergebener Parameter einer Funktion liegt ausserhalb seines gltigen Bereichs.
#define IV_ERROR_VARIABLE_UNDEFINED    21 // Die angegebene Variable ist nicht definiert.
#define IV_ERROR_VARIABLE_VALUE        26 // Der angegebene Wert einer Variablen konnte nicht bernommen werden.
#define IV_ERROR_PROCESSING            28 // Der Befehl konnte zwar bermittelt werden, wurde jedoch nicht ausgefhrt.
#define IV_ERROR_DEVICE_UNKNOWN        29 // Der Geraetetyp ist unbekannt. Update der Software erforderlich.
#define IV_ERROR_DEVICEFILE_WRONG      30 // Bei Geraeteupdate stimmt der Geraetetyp nicht mit dem der Geraetedatei ueberein.
#define IV_ERROR_DEVICE_WRONG          31 // Geraetetyp stimmt nicht. z.B. Versuchtes Einspielen von Setupdatei fuer PZE - Master IV in BDE - Master IV
#define IV_ERROR_FILE_EXTENSION        32 // Die vorliegende Dateiendung wird nicht unterstuetzt.
#define IV_ERROR_ENTRANCE2_OFF         39 // Die Zutrittskontrolle ist aus.
#define IV_ERROR_OVERFLOW              40 // Bei einer Datenbertragung ist ein Speicherberlauf eingetreten.
#define IV_ERROR_NO_DATA_AVAILABLE     41 // Es liegen keine Daten vor.
#define IV_ERROR_PROCESSING_DLL        42 // Der Befehl konnte zwar bermittelt werden, bei den Daten liegt jedoch ein fehler vor.

// Fehler fuer Listenfunktionen
#define IV_ERROR_NAME_UNKNOWN          33 // Der Tabellenname oder Spaltenname ist undefiniert.
#define IV_ERROR_HANDLE                34 // Ein angegebener Handle ist nicht gueltig.
#define IV_ERROR_NULL_RESULT           35 // Der anzuwendende Filter wuerde keine Datensaetze liefert.
#define IV_ERROR_BOF                   36 // Sprung fuehrte zum Anfang der Tabelle. (Base of File)
#define IV_ERROR_EOF                   37 // Sprung fuehrte zum Ende der Tabelle. (End of File)
#define IV_ERROR_VALUE                 38 // Der angegebene Wert ist Fehlerhaft.

#endif
