#-------------------------------------------------
#
# Project created by QtCreator 2014-01-15T13:19:11
#
#-------------------------------------------------

QT       -= qt core gui

TARGET = DFCom
TEMPLATE = lib

QMAKE_CXXFLAGS += -std=c++11

DEFINES += DATAFOXLIBRARYIV_LIBRARY AE3COM_EXPORT

INCLUDEPATH += ../Shared/boost

win32 {
    LIBS += -lversion -lws2_32
}

SOURCES += \
    api/src/df_access_control.cpp \
    api/src/df_access_control_lists.cpp \
    api/src/df_access_control_lists_v1.cpp \
    api/src/df_active_mode.cpp \
    api/src/df_api.cpp \
    api/src/df_connection.cpp \
    api/src/df_files.cpp \
    api/src/df_fingerprint.cpp \
    api/src/df_lists.cpp \
    api/src/df_log.cpp \
    api/src/df_setup_lists.cpp \
    api/src/df_setup_records.cpp \
    api/src/df_system_records.cpp \
    api/src/df_timeboy_lists.cpp \
    ChannelBridgeArray.cpp \
    DatafoxLibraryIV.cpp \
    libraryversion.cpp \
    ../Shared/Channel/Channel1_2.cpp \
    ../Shared/Channel/Channel4Base.cpp \
    ../Shared/Channel/Channel4Buffer.cpp \
    ../Shared/Channel/Channel4.cpp \
    ../Shared/Channel/Channel4ModuleApplication.cpp \
    ../Shared/Channel/Channel4ModuleHardware.cpp \
    ../Shared/Channel/Channel4ModuleSystem.cpp \
    ../Shared/Channel/Channel4ModuleTable.cpp \
    ../Shared/Channel/Channel4Protocol.cpp \
    ../Shared/Channel/Channel4ProtocolCrypt.cpp \
    ../Shared/Channel/ChannelBridge.cpp \
    ../Shared/Channel/TimeboyStation.cpp \
    ../Shared/Common/AEBuffer.cpp \
    ../Shared/Common/aescrypt.cpp \
    ../Shared/Common/aescryptsession.cpp \
    ../Shared/Common/crc.cpp \
    ../Shared/Common/DataFlash.cpp \
    ../Shared/Common/deviceinfo.cpp \
    ../Shared/Common/DF4Crypt.cpp \
    ../Shared/Common/DFComUtils.cpp \
    ../Shared/Common/DFSoftwareVersion.cpp \
    ../Shared/Common/hardwareinfo.cpp \
    ../Shared/Common/mcumemory.cpp \
    ../Shared/Common/md5.cpp \
    ../Shared/Common/softwareinfo.cpp \
    ../Shared/Common/tcpipinfo.cpp \
    ../Shared/DFItem/DFItemAccessControl2.cpp \
    ../Shared/DFItem/DFItemAccessControl.cpp \
    ../Shared/DFItem/DFItemBase.cpp \
    ../Shared/DFItem/DFItemDevice.cpp \
    ../Shared/DFItem/DFItemHandling.cpp \
    ../Shared/DFItem/DFItemInputChain.cpp \
    ../Shared/DFItem/DFItemInputChainField.cpp \
    ../Shared/DFItem/DFItemIOModule.cpp \
    ../Shared/DFItem/DFItemMDE.cpp \
    ../Shared/DFItem/DFItemMenuChoice.cpp \
    ../Shared/DFItem/DFItemMenu.cpp \
    ../Shared/DFItem/DFItemTable.cpp \
    ../Shared/DFItem/DFItemTableField.cpp \
    ../Shared/DFItem/DFItemTableList.cpp \
    ../Shared/DFItem/DFItemTableRecord.cpp \
    ../Shared/File/filedevice.cpp \
    ../Shared/File/filedevicetext.cpp \
    ../Shared/File/filedevicezip.cpp \
    ../Shared/File/filedisplaycolors.cpp \
    ../Shared/File/filedisplay.cpp \
    ../Shared/File/filehardwareinfo.cpp \
    ../Shared/File/fileini.cpp \
    ../Shared/File/fileintelhex.cpp \
    ../Shared/File/filestudio.cpp \
    ../Shared/File/filestudioxml.cpp \
    ../Shared/File/filetouchkeys.cpp \
    ../Shared/File/filewlanconfig.cpp \
    ../Shared/File/IniFile.cpp \
    ../Shared/Log/DFLogCheck.cpp \
    ../Shared/Log/DFLog.cpp \
    ../Shared/tinyxml/tinystr.cpp \
    ../Shared/tinyxml/tinyxml.cpp \
    ../Shared/tinyxml/tinyxmlerror.cpp \
    ../Shared/tinyxml/tinyxmlparser.cpp

win32 {
    SOURCES += ../Shared/zip_utils/zip.cpp
}

HEADERS += \
    api/df_access_control.h \
    api/df_access_control_lists.h \
    api/df_access_control_lists_v1.h \
    api/df_active_mode.h \
    api/df_api.h \
    api/df_connection.h \
    api/df_files.h \
    api/df_fingerprint.h \
    api/df_lists.h \
    api/df_log.h \
    api/df_setup_lists.h \
    api/df_setup_records.h \
    api/df_system_records.h \
    api/df_timeboy_lists.h \
    ChannelBridgeArray.h \
    DatafoxLibraryIV.h \
    include/UnixDef.h \
    libraryversion.h \
    resource.h \
    ../Shared/Channel/Channel1_2.h \
    ../Shared/Channel/Channel2Def.h \
    ../Shared/Channel/Channel4Base.h \
    ../Shared/Channel/Channel4Buffer.h \
    ../Shared/Channel/Channel4.h \
    ../Shared/Channel/Channel4ModuleApplication.h \
    ../Shared/Channel/Channel4ModuleHardware.h \
    ../Shared/Channel/Channel4ModuleSystem.h \
    ../Shared/Channel/Channel4ModuleTable.h \
    ../Shared/Channel/Channel4ProtocolCrypt.h \
    ../Shared/Channel/Channel4Protocol.h \
    ../Shared/Channel/ChannelBridge.h \
    ../Shared/Channel/TimeboyStation.h \
    ../Shared/Common/AEBuffer.h \
    ../Shared/Common/AEErrorDef.h \
    ../Shared/Common/aescrypt.h \
    ../Shared/Common/aescryptsession.h \
    ../Shared/Common/aes.h \
    ../Shared/Common/crc.h \
    ../Shared/Common/DataFlash.h \
    ../Shared/Common/deviceinfo.h \
    ../Shared/Common/DF4Crypt.h \
    ../Shared/Common/DFComAPI.h \
    ../Shared/Common/DFComUtils.h \
    ../Shared/Common/DFSoftwareVersion.h \
    ../Shared/Common/eeprom.h \
    ../Shared/Common/ErrorState.h \
    ../Shared/Common/ExtendedFlash.h \
    ../Shared/Common/hardwareinfo.h \
    ../Shared/Common/mcumemory.h \
    ../Shared/Common/md5.h \
    ../Shared/Common/Power.h \
    ../Shared/Common/pzemaiv.h \
    ../Shared/Common/softwareinfo.h \
    ../Shared/Common/tcpipinfo.h \
    ../Shared/Common/transponder.h \
    ../Shared/Common/typedef.h \
    ../Shared/DFItem/DFItemAccessControl2.h \
    ../Shared/DFItem/DFItemAccessControl.h \
    ../Shared/DFItem/DFItemBase.h \
    ../Shared/DFItem/DFItemDevice.h \
    ../Shared/DFItem/DFItemHandling.h \
    ../Shared/DFItem/DFItemInputChainField.h \
    ../Shared/DFItem/DFItemInputChain.h \
    ../Shared/DFItem/DFItemIOModule.h \
    ../Shared/DFItem/DFItemMDE.h \
    ../Shared/DFItem/DFItemMenuChoice.h \
    ../Shared/DFItem/DFItemMenu.h \
    ../Shared/DFItem/DFItems.h \
    ../Shared/DFItem/DFItemTableField.h \
    ../Shared/DFItem/DFItemTable.h \
    ../Shared/DFItem/DFItemTableList.h \
    ../Shared/DFItem/DFItemTableRecord.h \
    ../Shared/File/filedevice.h \
    ../Shared/File/filedevicetext.h \
    ../Shared/File/filedevicezip.h \
    ../Shared/File/filedisplaycolors.h \
    ../Shared/File/filedisplay.h \
    ../Shared/File/filehardwareinfo.h \
    ../Shared/File/fileini.h \
    ../Shared/File/fileintelhex.h \
    ../Shared/File/filestudio.h \
    ../Shared/File/filestudioxml.h \
    ../Shared/File/filetouchkeys.h \
    ../Shared/File/filewlanconfig.h \
    ../Shared/Log/DFLogCheck.h \
    ../Shared/Log/DFLog.h \
    ../Shared/tinyxml/tinystr.h \
    ../Shared/tinyxml/tinyxml.h \
    targetver.h

win32 {
    HEADERS +=
}

unix {
    target.path = /usr/lib
    INSTALLS += target
}

