#include "../df_log.h"
#include "../../DatafoxLibraryIV.h"

DF_API_EXTERN void DF_API_CALL DFCSetLogFileName( int connectionId, const unsigned char *filePath )
{
    ChannelBridge *pChannel = theApp.GetAEChannel( connectionId );
    // Wurde Channel-Objekt ermittelt.
    if ( pChannel == NULL )
        return;

    pChannel->logBegin( "%s\t%i\t%s", __func__, connectionId,
        (filePath == NULL) ? "" : (char*)filePath );

    // zulaessige Bereiche pruefen
    if ( filePath == NULL )
    {
        pChannel->logEnd( "" );
        return;
    }

    pChannel->setLogFileName( (const char*)filePath );

    pChannel->logEnd( "" );
}

DF_API_EXTERN void DF_API_CALL DFCSetLogOn( int connectionId )
{
    ChannelBridge *pChannel = theApp.GetAEChannel( connectionId );
    // Wurde Channel-Objekt ermittelt?
    if ( pChannel == NULL )
        return;

    pChannel->logBegin( "%s\t%i", __func__, connectionId );

    // Pruefe ob Channel vorhanden
    pChannel->setLogOn();

    pChannel->logEnd( "" );
}

DF_API_EXTERN void DF_API_CALL DFCSetLogOff( int connectionId )
{
    ChannelBridge *pChannel = theApp.GetAEChannel(connectionId);
    // Wurde Channel-Objekt ermittelt.
    if (pChannel == NULL)
    {
        return;
    }

    pChannel->logBegin("%s\t%i", __func__, connectionId);

    pChannel->setLogOff();

    pChannel->logEnd("");
}

DF_API_EXTERN int DF_API_CALL DFCLogOn( char *filePath )
{
    (void)filePath;

    //	pChannel->logBegin("%s\t%s", __func__, (szFileName == 0) ? "" : szFileName);

    //	pChannel->logEnd("\t(%i)", 0);
    // Wird nicht mehr unterstuetzt!
    return 0;
}

DF_API_EXTERN void DF_API_CALL DFCLogOff()
{
    //	pChannel->logBegin("%s", __func__);
    //	pChannel->logEnd("");
    // Wird nicht mehr unterstuetzt!
}
